package org.openxma.dsl.reference.dao.impl;

import java.io.Serializable;

import org.hibernate.EmptyInterceptor;
import org.hibernate.Transaction;
import org.hibernate.type.Type;

public class AuditInterceptor extends EmptyInterceptor {
    private static final long serialVersionUID = 1L;
    private int dirtyFlushCounter;

    public int getDirtyFlushCounter() {
        return dirtyFlushCounter;
    }

    @Override
    public boolean onFlushDirty(Object entity, Serializable id, Object[] currentState, Object[] previousState,
            String[] propertyNames, Type[] types) {
        dirtyFlushCounter++;
        return super.onFlushDirty(entity, id, currentState, previousState, propertyNames, types);
    }

    @Override
    public void afterTransactionCompletion(Transaction tx) {
        super.afterTransactionCompletion(tx);
    }

    public void reset() {
        dirtyFlushCounter=0;
    }

}
