package org.openxma.dsl.reference.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.dsl.reference.dao.SingleRoleGroupDao;
import org.openxma.dsl.reference.model.SingleRole;
import org.openxma.dsl.reference.model.impl.SingleRoleImpl;
/**
 * @see SingleRoleGroupDao
 */
@SuppressWarnings("unused")
public abstract class SingleRoleGroupDaoGenImpl extends GenericDaoHibernateImpl<SingleRole,String> implements SingleRoleGroupDao {
	
	public SingleRoleGroupDaoGenImpl() {
		super(SingleRoleImpl.class);
	}
	
	/**
	 * @param context the context for the object creation
	 * @return a transient instance of entity <code>SingleRole</code> with an already assigned identifier.
	 */
	public SingleRole createEntity(Object context) {
		return create();
	}
	
	public SingleRole create() 
	{
		SingleRole singleRole = createEntityInstance();
		singleRole.setOid(dataFieldMaxValueIncrementer.nextStringValue());
		return singleRole;
	}
	
	protected Mapper getNamedQueryMapper(String queryName) {
		return new SingleRoleGroupDaoQueryMapper();
	}
	
	protected class SingleRoleGroupDaoQueryMapper extends NamedQueryMapper {
		
	@SuppressWarnings("unchecked")
	public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
		return super.mapOne(sourceObject, targetObject);
	}
}
}
