package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import org.openxma.dsl.reference.dto.CategoryView;
import org.openxma.dsl.reference.dto.ProductView;

public abstract class CategoryViewGen implements Serializable {
	private static final long serialVersionUID = 1411981526;
	protected List<CategoryView> subCategories;
	protected List<ProductView> products;
	protected Long oid;
	protected String name;
	protected String displayName;
	protected Long parentCategoryOid;
	
	public List<CategoryView> getSubCategories() {
		return this.subCategories;
	}
	
	public void setSubCategories(List<CategoryView> subCategories) {
		this.subCategories=subCategories;
	}
	
	public void addSubCategories(CategoryView subCategories) {
		if (subCategories == null) {
			throw new IllegalArgumentException("parameter 'subCategories' must not be null");
		}
		if (getSubCategories() == null) {
			this.subCategories = new ArrayList<CategoryView>();
		}
		this.subCategories.add(subCategories);
	}
	
	public List<ProductView> getProducts() {
		return this.products;
	}
	
	public void setProducts(List<ProductView> products) {
		this.products=products;
	}
	
	public void addProducts(ProductView products) {
		if (products == null) {
			throw new IllegalArgumentException("parameter 'products' must not be null");
		}
		if (getProducts() == null) {
			this.products = new ArrayList<ProductView>();
		}
		this.products.add(products);
	}
	
	public Long getOid() {
		return this.oid;
	}
	
	public void setOid(Long oid) {
		this.oid=oid;
	}
	
	public String getName() {
		return this.name;
	}
	
	public void setName(String name) {
		this.name=name;
	}
	
	public String getDisplayName() {
		return this.displayName;
	}
	
	public void setDisplayName(String displayName) {
		this.displayName=displayName;
	}
	
	public Long getParentCategoryOid() {
		return this.parentCategoryOid;
	}
	
	public void setParentCategoryOid(Long parentCategoryOid) {
		this.parentCategoryOid=parentCategoryOid;
	}
	
	
	@Override
	public String toString() {
		StringBuilder toStringBuilder = new StringBuilder("CategoryView [");
		toStringBuilder.append("oid=").append(getOid()).append(",");
		toStringBuilder.append("name=").append(getName()).append(",");
		toStringBuilder.append("displayName=").append(getDisplayName()).append(",");
		toStringBuilder.append("parentCategoryOid=").append(getParentCategoryOid());
		return toStringBuilder.append("]").toString();
	}
}
