package org.openxma.dsl.reference.jsr303.validation;

import java.util.HashSet;
import java.util.Set;
import org.openxma.dsl.platform.validation.Jsr303Validators;
import org.openxma.dsl.reference.jsr303.model.Jsr303TestEntity;
import org.openxma.dsl.reference.jsr303.model.impl.Jsr303TestEntityGenImpl.IsStrConstraint1Enabled;
import org.openxma.dsl.reference.jsr303.validation.ValidJsr303TestEntity;


@SuppressWarnings("boxing")
public abstract class Jsr303TestEntityGenValidator extends Jsr303Validators<ValidJsr303TestEntity, Jsr303TestEntity> {
	
	protected Set<Class<?>> createGroups(Jsr303TestEntity jsr303TestEntity) {
		Set<Class<?>> groups = new HashSet<Class<?>>();
		if (isStrConstraint1Enabled(jsr303TestEntity)) {
			groups.add(IsStrConstraint1Enabled.class);
		}
		return groups;
	}
	
	public boolean isStrConstraint1Enabled(Jsr303TestEntity jsr303TestEntity) {
		return (jsr303TestEntity.getCategory()!=null);
	}
}
