package org.openxma.dsl.reference.model;

import java.util.Date;
import java.util.Set;
import org.openxma.dsl.reference.base.model.BaseEntity;
import org.openxma.dsl.reference.model.Customer;
import org.openxma.dsl.reference.model.OrderItem;
import org.openxma.dsl.reference.types.valueobject.OrderNumber;

public interface OrderGen extends BaseEntity  {

	OrderNumber getOrderNumber();
	void setOrderNumber(OrderNumber orderNumber);

	String getStoreId();
	void setStoreId(String storeId);

	Date getPlacementDate();
	void setPlacementDate(Date placementDate);

	Date getDeliveryDate();
	void setDeliveryDate(Date deliveryDate);

	String getOrderState();
	void setOrderState(String orderState);

	Integer getTaxes();
	void setTaxes(Integer taxes);

	Double getTotalAmount();
	void setTotalAmount(Double totalAmount);

	Customer getCustomer();
	void setCustomer(Customer customer);

	Set<OrderItem> getOrderItems();
	boolean hasOrderItems();
	void addOrderItems(OrderItem orderItems);
	void removeOrderItems(OrderItem orderItems);
	void removeAllOrderItems();
}
