package org.openxma.dsl.reference.model;

import java.util.Date;
import java.util.Set;
import org.openxma.dsl.reference.model.Category;
import org.openxma.dsl.reference.model.Certificate;
import org.openxma.dsl.reference.model.ProductImage;
import org.openxma.dsl.reference.model.Supplier;
import org.openxma.dsl.reference.types.valueobject.ProductId;

public interface ProductGen  {

	ProductId getOid();
	void setOid(ProductId oid);

	Date getVersion();
	void setVersion(Date version);

	String getName();
	void setName(String name);

	Integer getUnitPrice();
	void setUnitPrice(Integer unitPrice);

	Integer getUnitOnStock();
	void setUnitOnStock(Integer unitOnStock);

	Integer getUnitOnOrder();
	void setUnitOnOrder(Integer unitOnOrder);

	Supplier getSupplier();
	void setSupplier(Supplier supplier);

	ProductImage getProductImage();
	void setProductImage(ProductImage productImage);

	Set<Category> getCategories();
	boolean hasCategories();
	void addCategories(Category categories);
	void removeCategories(Category categories);
	void removeAllCategories();

	Certificate getCert1();
	void setCert1(Certificate cert1);

	Certificate getCert2();
	void setCert2(Certificate cert2);

	Certificate getCert3();
	void setCert3(Certificate cert3);
}
