package org.openxma.dsl.reference.types.valueobject;

/**
 * Represents a custom DataType for <code>VOBoolean</code>.
 */
public class VOBoolean extends org.openxma.dsl.platform.valueobject.ValueObjectBoolean {

    /**
     * Put the control and responsibility on the developer to determine the version of the
     * serialization class with which a serialized object is compatible.
     */
    private static final long serialVersionUID = 100L;

    /**
     * default ctor
     */
    public VOBoolean(Boolean pBoolean) {
    	super(pBoolean);
    }

    /**
     * Create a new instance of VOBoolean or return null depending on input.
     */
    public static VOBoolean newOrNull(Boolean pBoolean) {
        if (pBoolean != null) {
            return new VOBoolean(pBoolean);
        }
        return null;
    }

/**
 * Create a new instance of VOBoolean or return null depending on input.
 */
public static VOBoolean newOrNull(String value) {
    if (value != null && value.length() > 0) {
        return new VOBoolean(Boolean.valueOf(value));
    }
    return null;
}

}
