package org.openxma.dsl.reference.ui.layouting.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.component.*;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;

/**
 * This class implements the generic client part of LayoutingPage.
 * It implements the widgets and models of the page.
 *
 */
public abstract class LayoutingPageGen extends org.openxma.dsl.platform.xma.client.DslDialogPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    private Scaler scaler = null;
    Notebook LayoutingPage_tabfolder_0_0_0_0;
    TabFolder LayoutingPage_tabfolder_0_0_0_0W;
    AbsoluteAttachment absoluteAttachment;
    RelativeAttachment relativeAttachment;
    TabulatorAttachment tabulatorAttachment;
    AbsoluteCharAttachment absoluteCharAttachment;
    SiblingAttachment siblingAttachment;
    FieldParts fieldParts;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the LayoutingPageGen.
     * @param parent the parent page
     */
    public LayoutingPageGen(PageClient parent) {
        super(parent,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the LayoutingPageGen.
     * @param component the component this page belongs to
     */
    public LayoutingPageGen(ComponentClient component) {
        super(component,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the LayoutingPageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     */
    public LayoutingPageGen(ComponentClient component, Shell parentShell) {
        super(component,parentShell,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the LayoutingPageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     * @param modal the SWT-style for the desired modality
     */
    public LayoutingPageGen(ComponentClient component, Shell parentShell, int modal) {
        super(component,parentShell,false,modal|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }


    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.layouting.client.Layouting",getGenPageLocale());
        }
        return genPageMessages;
    }

    /*
     * returns the scaler used for this page
    */
    final protected Scaler getScaler() {
        if (scaler == null) {
            scaler = Scaler.getInstance(getComposite());
        }
        return scaler;
    }

    /**
     * Gives the URI of the help for this page
     * This URI is relative to the download-URI of the component
     * @return the relative URI of the help for this page
     */
    public String getHelpUri() {
        return "help/org/openxma/dsl/reference/ui/layouting/LayoutingPage.html";
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {

        widgetModels = new WModel[] {  };
        LayoutingPage_tabfolder_0_0_0_0 = new Notebook(this);
        absoluteAttachment = new AbsoluteAttachment(LayoutingPage_tabfolder_0_0_0_0);
        LayoutingPage_tabfolder_0_0_0_0.addPage(absoluteAttachment);
        relativeAttachment = new RelativeAttachment(LayoutingPage_tabfolder_0_0_0_0);
        LayoutingPage_tabfolder_0_0_0_0.addPage(relativeAttachment);
        tabulatorAttachment = new TabulatorAttachment(LayoutingPage_tabfolder_0_0_0_0);
        LayoutingPage_tabfolder_0_0_0_0.addPage(tabulatorAttachment);
        absoluteCharAttachment = new AbsoluteCharAttachment(LayoutingPage_tabfolder_0_0_0_0);
        LayoutingPage_tabfolder_0_0_0_0.addPage(absoluteCharAttachment);
        siblingAttachment = new SiblingAttachment(LayoutingPage_tabfolder_0_0_0_0);
        LayoutingPage_tabfolder_0_0_0_0.addPage(siblingAttachment);
        fieldParts = new FieldParts(LayoutingPage_tabfolder_0_0_0_0);
        LayoutingPage_tabfolder_0_0_0_0.addPage(fieldParts);
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Layouting.LayoutingPageClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Layouting getTypedComponent() {
        return (Layouting) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = getScaler();

        final Shell shell = getShell();
        if(getDialog()==this) {
            shell.setText(getGenPageMessages().getString("LayoutingPage"));
            shell.addHelpListener(adapter);
        } else {
            getComposite().addHelpListener(adapter);
        }
        Composite LayoutingPageCompW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        LayoutingPageCompW.setLayout(layout);

        LayoutingPage_tabfolder_0_0_0_0W = (TabFolder)LayoutingPage_tabfolder_0_0_0_0.createComposite(LayoutingPageCompW);
        LayoutingPage_tabfolder_0_0_0_0W.addHelpListener(LayoutingPage_tabfolder_0_0_0_0);
        absoluteAttachment.createTabItem(LayoutingPage_tabfolder_0_0_0_0W,0);
        relativeAttachment.createTabItem(LayoutingPage_tabfolder_0_0_0_0W,1);
        tabulatorAttachment.createTabItem(LayoutingPage_tabfolder_0_0_0_0W,2);
        absoluteCharAttachment.createTabItem(LayoutingPage_tabfolder_0_0_0_0W,3);
        siblingAttachment.createTabItem(LayoutingPage_tabfolder_0_0_0_0W,4);
        fieldParts.createTabItem(LayoutingPage_tabfolder_0_0_0_0W,5);
        LayoutingPage_tabfolder_0_0_0_0W.setData("WIDGET_ID","LayoutingPage_tabfolder_0_0_0_0W");

        widgets = new Control[] { LayoutingPage_tabfolder_0_0_0_0W };

        createWidgetsLayout();
        createWidgetsTabOrder();

        if(getDialog()==this) {
            shell.setSize(scaler.convertXToCurrent(640), scaler.convertYToCurrent(480));
        }
    }

    /**
     * Create the layout of all SWT-Widgets of the page.
     * (Attachments, Distances, Sizes)
     */
    public void createWidgetsLayout() {
        FormData data;
        final Scaler scaler = getScaler();
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        LayoutingPage_tabfolder_0_0_0_0W.setLayoutData(data);

    }

    /**
     * Create the tab order of all SWT-Widgets of the page.
     * (sets the focus and defines the tab order)
     */
    protected void createWidgetsTabOrder() {
        Control[] tabOrder;
        final Shell shell = getShell();
        final Composite LayoutingPageCompW = getComposite();
        if(getDialog()==this) {
            shell.setTabList(new Control[] { LayoutingPageCompW });
        }
        tabOrder = new Control[1];
        tabOrder[0] = LayoutingPage_tabfolder_0_0_0_0W;
        LayoutingPageCompW.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        LayoutingPage_tabfolder_0_0_0_0W = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
    }

    /**
     * This method will be called every time the LayoutingPage becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

}
