package org.openxma.dsl.reference.validation;

import org.openxma.dsl.platform.validation.Validators;
import org.openxma.dsl.reference.model.Category;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class CategoryGenValidator extends Validators {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return Category.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(Category category) {
		Errors errors = createErrors(category);
		validate(category,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		Category category = (Category) object;
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "field.required");
		
	}
}
