package org.openxma.dsl.reference.validation;

import org.openxma.dsl.reference.base.validation.BaseEntityValidator;
import org.openxma.dsl.reference.model.OrderItem;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class OrderItemGenValidator extends BaseEntityValidator {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return OrderItem.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(OrderItem orderItem) {
		Errors errors = createErrors(orderItem);
		super.validate(orderItem,errors);
		validate(orderItem,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		OrderItem orderItem = (OrderItem) object;
		ValidationUtils.rejectIfEmpty(errors, "itemNo", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "quantity", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "order", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "product", "field.required");
		
	}
}
