package org.openxma.dsl.reference.validation;

import org.openxma.dsl.platform.validation.Validators;
import org.openxma.dsl.reference.model.Product;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class ProductGenValidator extends Validators {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return Product.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(Product product) {
		Errors errors = createErrors(product);
		validate(product,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		Product product = (Product) object;
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "unitPrice", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "supplier", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "cert1", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "cert2", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "cert3", "field.required");
		
	}
}
