package org.openxma.dsl.reference.validation;

import org.openxma.dsl.reference.base.validation.BaseEntityValidator;
import org.openxma.dsl.reference.model.VOData;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class VODataGenValidator extends BaseEntityValidator {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return VOData.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(VOData vOData) {
		Errors errors = createErrors(vOData);
		super.validate(vOData,errors);
		validate(vOData,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		VOData vOData = (VOData) object;
		ValidationUtils.rejectIfEmpty(errors, "pVOBigDecimal", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "pVODate", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "pVOTimestamp", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "pVODouble", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "pVOFloat", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "pVOLong", "field.required");
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "pVOString", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "pVOBoolean", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "pVOI18Enumeration", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "pVOByteArray", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "pVOXml", "field.required");
		ValidationUtils.rejectIfEmpty(errors, "pVOXml2", "field.required");
		
	}
}
