package org.openxma.dsl.reference.validatortest.validation;

import org.openxma.dsl.platform.validation.Validators;
import org.openxma.dsl.reference.validatortest.model.SpringTestBaseEntity;
import org.springframework.validation.Errors;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class SpringTestBaseEntityGenValidator extends Validators {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return SpringTestBaseEntity.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(SpringTestBaseEntity springTestBaseEntity) {
		Errors errors = createErrors(springTestBaseEntity);
		validate(springTestBaseEntity,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		SpringTestBaseEntity springTestBaseEntity = (SpringTestBaseEntity) object;
		rejectIfMaxLength(errors,"baseString",springTestBaseEntity.getBaseString(),10);
		
		if (isBaseStringConstraint1Enabled(springTestBaseEntity)) {
			rejectIfMinLength(errors,"baseString",springTestBaseEntity.getBaseString(),5);
			rejectIfMaxLength(errors,"baseString",springTestBaseEntity.getBaseString(),10);
		}
	}
	
	public boolean isBaseStringConstraint1Enabled(SpringTestBaseEntity springTestBaseEntity) {
		return Boolean.TRUE;
	}
}
