package org.openxma.dsl.reference.validatortest.validation;

import org.openxma.dsl.reference.validatortest.model.SpringTestEntity;
import org.openxma.dsl.reference.validatortest.validation.SpringTestBaseEntityValidator;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import static org.openxma.dsl.platform.validation.ValidatorsHelper.*;


@SuppressWarnings("boxing")
public abstract class SpringTestEntityGenValidator extends SpringTestBaseEntityValidator {
	
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return SpringTestEntity.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(SpringTestEntity springTestEntity) {
		Errors errors = createErrors(springTestEntity);
		super.validate(springTestEntity,errors);
		validate(springTestEntity,errors);
		return errors;
	}
	
	public void validate(Object object, Errors errors) {
		SpringTestEntity springTestEntity = (SpringTestEntity) object;
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "str", "field.required");
		rejectIfMaxLength(errors,"str",springTestEntity.getStr(),5);
		
		if (isStrConstraint1Enabled(springTestEntity)) {
			rejectIfMinLength(errors,"str",springTestEntity.getStr(),3);
			rejectIfMaxLength(errors,"str",springTestEntity.getStr(),10);
		}
	}
	
	public boolean isStrConstraint1Enabled(SpringTestEntity springTestEntity) {
		return (springTestEntity.getCategory()!=null);
	}
}
