package org.openxma.dsl.reference.xma.tablewithmenucomponent.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.component.*;
import at.spardat.xma.appshell.*;
import at.spardat.xma.appshell.MenuItem;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.xma.mdl.table.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of MainPage.
 * It implements the widgets and models of the page.
 *
 */
public abstract class MainPageGen extends MultiMenuAppShell {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    private Scaler scaler = null;
    Composite paramPanelW;
    Composite paramPanel_set0W;
    Label paramPanel_set0_centered;
    Table paramTableW;
    at.spardat.xma.mdl.table.TableLayoutManager paramTableWLM;
    ITableWMClient paramTable;
    static final int PARAMTABLE_FIRSTNAME = 0;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the MainPageGen.
     * @param parent the parent page
     */
    public MainPageGen(PageClient parent) {
        super(parent,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the MainPageGen.
     * @param component the component this page belongs to
     */
    public MainPageGen(ComponentClient component) {
        super(component,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the MainPageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     */
    public MainPageGen(ComponentClient component, Shell parentShell) {
        super(component,parentShell,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the MainPageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     * @param modal the SWT-style for the desired modality
     */
    public MainPageGen(ComponentClient component, Shell parentShell, int modal) {
        super(component,parentShell,false,modal|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }


    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.xma.tablewithmenucomponent.client.TableWithMenuComponent",getGenPageLocale());
        }
        return genPageMessages;
    }

    /*
     * returns the scaler used for this page
    */
    final protected Scaler getScaler() {
        if (scaler == null) {
            scaler = Scaler.getInstance(getComposite());
        }
        return scaler;
    }

    /**
     * Gives the URI of the help for this page
     * This URI is relative to the download-URI of the component
     * @return the relative URI of the help for this page
     */
    public String getHelpUri() {
        return "help/org/openxma/dsl/reference/xma/tablewithmenucomponent/MainPage.html";
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        IFmt formatter;
        paramTable = new TableWMClient((short) 0,this,1,TableWMClient.S_NULL|TableWM.S_ONE_WAY);
        formatter = AStringFmt.getInstance(25);
        ((TableWMClient)paramTable).getColumn(PARAMTABLE_FIRSTNAME).setFormatter(formatter);

        widgetModels = new WModel[] { (WModel) paramTable };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        paramTable = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return TableWithMenuComponent.MainPageClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public TableWithMenuComponent getTypedComponent() {
        return (TableWithMenuComponent) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = getScaler();

        final Shell shell = getShell();
        if(getDialog()==this) {
            shell.setText(getGenPageMessages().getString("MainPage"));
            shell.addHelpListener(adapter);
        } else {
            getComposite().addHelpListener(adapter);
        }
        Composite MainPageCompW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        MainPageCompW.setLayout(layout);

        paramPanelW = new Composite(MainPageCompW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        paramPanelW.setLayout(layout);
        paramPanelW.setData("WIDGET_ID","paramPanelW");

        paramPanel_set0W = new Composite(paramPanelW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        paramPanel_set0W.setLayout(layout);
        paramPanel_set0W.setData("WIDGET_ID","paramPanel_set0W");

        paramPanel_set0_centered = new Label(paramPanel_set0W,SWT.LEFT);
        paramPanel_set0_centered.setVisible(false);
        paramPanel_set0_centered.setData("WIDGET_ID","paramPanel_set0_centered");

        paramTableW = new Table(paramPanel_set0W,SWT.SINGLE|SWT.BORDER|SWT.FULL_SELECTION);
        paramTableW.setHeaderVisible(true);
        paramTableW.setLinesVisible(true);
        paramTableW.setData("WIDGET_ID","paramTableW");
        paramTableW.addSelectionListener(adapter);
        TableColumn paramTable_firstName = new TableColumn(paramTableW,SWT.LEFT);
        paramTable_firstName.setText(getGenPageMessages().getString("MainPage.paramTable_firstName"));
        paramTable_firstName.addSelectionListener(adapter);
        paramTableW.addMouseListener(adapter);
        Menu paramTableWCM = new Menu(paramTableW.getShell());
        org.eclipse.swt.widgets.MenuItem paramTableWCMI = new org.eclipse.swt.widgets.MenuItem(paramTableWCM, SWT.PUSH);
        paramTableWCMI.setText("Copy text");
        paramTableWCMI.addSelectionListener(adapter);
        paramTableW.setMenu(paramTableWCM);
        paramTableWLM = new at.spardat.xma.mdl.table.TableLayoutManager();
        paramTableWLM.manageTable(paramTableW,at.spardat.xma.mdl.table.TableLayoutManager.NONE);
        paramTableWLM.setMinLimit(scaler.convertXToCurrent(10));

        widgets = new Control[] { paramPanelW, paramPanel_set0W, paramPanel_set0_centered, paramTableW };

        createWidgetsLayout();
        createWidgetsTabOrder();

        if(getDialog()==this) {
            shell.setSize(scaler.convertXToCurrent(640), scaler.convertYToCurrent(480));
        }
    }

    /**
     * Create the layout of all SWT-Widgets of the page.
     * (Attachments, Distances, Sizes)
     */
    public void createWidgetsLayout() {
        FormData data;
        final Scaler scaler = getScaler();
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        paramPanelW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        paramPanel_set0W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        paramPanel_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        paramTableW.setLayoutData(data);

    }

    /**
     * Create the tab order of all SWT-Widgets of the page.
     * (sets the focus and defines the tab order)
     */
    protected void createWidgetsTabOrder() {
        Control[] tabOrder;
        final Shell shell = getShell();
        final Composite MainPageCompW = getComposite();
        if(getDialog()==this) {
            shell.setTabList(new Control[] { MainPageCompW });
        }
        tabOrder = new Control[1];
        tabOrder[0] = paramPanelW;
        MainPageCompW.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = paramPanel_set0W;
        paramPanelW.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = paramTableW;
        paramPanel_set0W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        paramPanelW = null;
        paramPanel_set0W = null;
        paramPanel_set0_centered = null;
        paramTableW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        TableColumn[] cols;
        paramTableW.setData(paramTable.getUIDelegate());
        paramTable.getUIDelegate().attachUI(paramTableW,null);
        cols = paramTableW.getColumns();
        for(int i = 0; i<cols.length; i++) {
            cols[i].setData(paramTable.getUIDelegate());
        }
        if (paramTableW.getMenu() != null) {
           for(org.eclipse.swt.widgets.MenuItem item : paramTableW.getMenu().getItems()) {
               item.setData(paramTable.getUIDelegate());
           }
        }

    }

    /**
     * This method will be called every time the MainPage becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

    /**
     * This method has to create the root task for the drop down menu.
     * This root task will be called immediately after the window of the AppShell
     * is opened and takes over the job of creating the main menu
     * @param rootMenu where the root task can add its menu items
     * @return the root task of the drop down menu.
     */
    public ITask createDropDownMenuRootTask(IMenuItem rootMenu) {
        return new Task(this) {
            public void run() {
                MenuItem mnumenuFile = new MenuItem("MainPage.menuFile");
                menu.addItem(mnumenuFile);
            }
        };
    }

    /**
     * Get the ResourceBundle containing the labels for all menu items.
     * @return the ResourceBundle for the menu.
     */
    public ResourceBundle getMenuResource() {
        return getGenPageMessages();
    }

}
